Lua_CrazyEggsExtraRewardItem = class("Lua_CrazyEggsExtraRewardItem", Lua_ListCell);
function Lua_CrazyEggsExtraRewardItem:ctor(p)
	self:superCall("ctor", p, "CrazyEggsExtraRewardItem_skin");
end

function Lua_CrazyEggsExtraRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
	self.effectArr = Array();

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(3);
	self.rItem:setMaxShow(3);
	self.rItem:setLayout(76, 76, 3);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.88, 0.88);
	self.rItem:setLocation(-139, -20);

	self.getBtn:addClickFuntion(self,self.onGetBtnClick);
end

function Lua_CrazyEggsExtraRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local smash_times;
	if DataCenter.crazyEggsData.smash_times >= data.times then
		smash_times = "[13A100]"..data.times.."[-]";
	else
		smash_times = "[F42A2A]"..DataCenter.crazyEggsData.smash_times.."[-]";
	end
	self.title.text = LanUtil.formateStr(LanUtil.getValue(144607), tostring(data.times), smash_times, tostring(data.times));
	
	if data.reward_flag == 0 then
		self.getBtn.label = LanUtil.getValue(144608);
	elseif data.reward_flag == 1 then
		self.getBtn.label = LanUtil.getValue(144608);
	elseif data.reward_flag == 2 then
		self.getBtn.label = LanUtil.getValue(144609);
	end
	self.getBtn:setBtnEnable(data.reward_flag == 1);
	self.redDot:setEnable(data.reward_flag == 1);

	local reward;
	local rewardArr = Array();
	for i = 1, data.itemArr:getSize() do
		rewardArr:add(data.itemArr[i].vo);
	end
	self.rItem:setRewardByArray(rewardArr);

	if self.effectArr:getSize() > 0 then
		self.effectArr:clear();
	end
	for i = 1, data.itemArr:getSize() do
		if data.itemArr[i].show_effect == 1 then
			reward = self.rItem:getToolImageById(data.itemArr[i].vo.id)
			self.effectArr:add(reward);
		end
	end
end

function Lua_CrazyEggsExtraRewardItem:checkOutBound(showRect)
	local width = self.rItem.rowInterval * self.rItem._itemScaleX;
	local height = self.rItem.colInterval * self.rItem._itemScaleY;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - 18 - height / 2, width, height);
	for i = 1, self.effectArr:getSize() do
		if self.effectArr[i].data.subType == Lua_PackTypeDefine.STAMP_ITEM then
			self.effectArr[i]:showStampEff(showRect:containeRect(rect));
		else
			self.effectArr[i]:showRoundEff(showRect:containeRect(rect));
		end
	end
end

function Lua_CrazyEggsExtraRewardItem:onGetBtnClick()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.CRAZY_EGGS, self._data.index);
end

function Lua_CrazyEggsExtraRewardItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.effectArr ~= nil then
		self.effectArr:dispose();
		self.effectArr:clear();
		self.effectArr = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end