Lua_CrazyEggsItem = class("Lua_CrazyEggsItem", Lua_DisplayObject)
function Lua_CrazyEggsItem:ctor(p)
	self:superCall("ctor", p, "CrazyEggsItem_skin");
end

function Lua_CrazyEggsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rItem = Lua_ToolImage.new(self.content);
	self.rItem:setDepth(10);
	self.rItem:setCanClick(true);
	self.rItem:setLocation(0, 26, 0);
	self.rItem:setScale(0.85, 0.85);
	self.rItem:setEnable(false);
end

function Lua_CrazyEggsItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.color == 0 then
		self.tagBg:setEnable(false);
		self.tagTxt:setEnable(false);
		if data.open == 0 then
			self.egg:setEnable(true);
			self.egg:setAltas("crazyEggs_atlas", "ui_jdjc_icon_s");
		else
			self.egg:setAltas("crazyEggs_atlas", "ui_jdjc_icon02_s");
		end
	else
		self.tagBg:setEnable(true);
		self.tagTxt:setEnable(true);
		if data.open == 0 then
			self.egg:setEnable(true);
			self.egg:setAltas("crazyEggs_atlas", "ui_jdjc_icon");
		else
			self.egg:setAltas("crazyEggs_atlas", "ui_jdjc_icon02");
		end
	end

	if data.open == 1 then
		self.egg:removeClickFuntion(self, self.onIconClick);
		if data.vo ~= nil and data.show_effect ~= nil then
			self.rItem:setEnable(true);
			self.rItem.data = data.vo;

			if data.show_effect == 1 then
				self.rItem:showRoundEff(true);
				if roundEff ~= nil then
					self.rItem.roundEff:SetRenderQueue(self.rItem.item_bg, 5, 2, true);
				end
			end
		end
	else
		self.rItem:setEnable(false);
		self.egg.clickScale = false;
		self.egg:addClickFuntion(self, self.onIconClick);
	end
end

function Lua_CrazyEggsItem:onIconClick(go)
	if self.data == nil then
		return;
	end

	if DataCenter.crazyEggsData.isSmashAll then
		return;
	end

	if DataCenter.crazyEggsData:getEggSmashSelect(self.data.index) == true then
		return;
	end

	local noOpenEggsCount = 0;
	local allEggsArr = DataCenter.crazyEggsData.getEggsList;
	for i = 1, allEggsArr:getSize() do
		if allEggsArr[i].open == 0 then
			noOpenEggsCount = noOpenEggsCount + 1;
		end
	end

	local backInfo = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if noOpenEggsCount > backInfo:getLeftSize() then
		OperateAlert.show(LanUtil.getValue(110863));
		return;
	end

	local str = "["..Lua_ColorDefine.GREEN_STR.."]"..self.data.cost.."[-]";
	self.enoughGold = true;
	if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.data.cost then
		str = "["..Lua_ColorDefine.RED_STR.."]"..self.data.cost.."[-]";
		self.enoughGold = false;
	end

	if DataCenter.neverTip:getNeverValue("SmashOneCost") == true then
		if self.enoughGold == false then
			DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.data.cost, true, true);
		else
			self:playEffect();
			DataCenter.crazyEggsData.isSmashOne = true;
			DataCenter.crazyEggsData:setEggSmashSelect(self.data.index, true);

			self.playTime = 2;
			Lua_CommonUtil.addTimer("SmashOneTimeDown", 1, self, self.smashOneTimeDown);
		end
		return;
	end

	local egg = LanUtil.getValue(144616);
	if self.data.color == 0 then
		egg = LanUtil.getValue(144615);
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		neverTip = "SmashOneCost",
		des = LanUtil.formateStr(LanUtil.getValue(144612), str, egg),
		type = 1,
		subFun = self.onSureFun
	});
end

function Lua_CrazyEggsItem:onSureFun()
	if self.enoughGold == false then
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.data.cost, true, true);
	else
		self:playEffect();
		DataCenter.crazyEggsData.isSmashOne = true;
		DataCenter.crazyEggsData:setEggSmashSelect(self.data.index, true);

		self.playTime = 2;
		Lua_CommonUtil.addTimer("SmashOneTimeDown", 1, self, self.smashOneTimeDown);
	end
end

function Lua_CrazyEggsItem:playEffect()
	if self.data == nil then return end

	if self.data.open == 0 then
		local posX = self.egg.mainContent.transform.localPosition.x ;
		local posY = self.egg.mainContent.transform.localPosition.y ;
		if self.effectEgg ~= nil then
			self.effectEgg:dispose();
			self.effectEgg = nil;
		end
		self.effectEgg = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..self.data.effect, self.data.effect, 0, 0);
		self.effectEgg:SetRenderQueue(self.egg, 5, 2, false);
		self.effectEgg:setLocation(posX, posY, 0);
		self.effectEgg:setDepth(10);

		if self.data.color == 0 then
			self.egg:setAltas("crazyEggs_atlas", "ui_jdjc_icon02_s");
		else
			self.egg:setAltas("crazyEggs_atlas", "ui_jdjc_icon02");
		end
	end
end

function Lua_CrazyEggsItem:smashOneTimeDown()
	self.playTime = self.playTime - 1;
	if self.playTime <= 0 then
		DataCenter.crazyEggsData.isSmashOne = false;
		if self.effectEgg ~= nil then
			self.effectEgg:dispose();
			self.effectEgg = nil;
		end
		Lua_ProxyManager.getProxy("Lua_CrazyEggsProxy"):sSmashOneEgg(Lua_OperationalActivitiesData.CRAZY_EGGS, self.data.index);

		Lua_CommonUtil.removeTimer(self, self.smashOneTimeDown);
	end
end

function Lua_CrazyEggsItem:dispose()
	if self.effectEgg ~= nil then
		self.effectEgg:dispose();
		self.effectEgg = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.smashOneTimeDown);

	self:superCall("dispose");
end