Lua_CrazyEggsRecordItem = class("Lua_CrazyEggsRecordItem", Lua_DragContainerItem);
function Lua_CrazyEggsRecordItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CrazyEggsRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self._height = 0;
	self.itemInfo = {};

	self.label = UICreate.createLabel(self.content, "", 102, 0, 338, 30, 22);
	self.label.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.label.pivot = UIWidget.Pivot.TopLeft;
	self.label.spacingY = 5;
	self.label:setDepth(5);

	self.fenGeXian = UICreate.createUIAtlasImage(self.content, "crazyEggs_atlas", "ui_jdjc_x", 0, 0, 340, 2);
	self.fenGeXian:setDepth(5);
end

function Lua_CrazyEggsRecordItem:setData(data)
	self.data = data;

	if data ~= nil then
		local arr = data.itemArr;
		local itemStr = "";
		local str;
		for i = 1, arr:getSize() do
			self.itemInfo[arr[i].item_id] = arr[i].vo;
			if itemStr == "" then
				itemStr = "";
			else
				itemStr = itemStr.."[7D3907]、[-]";
			end

			str = "[u][url=showItem_"..arr[i].item_id;
			if arr[i].amount > 1 then
				str = str.."]["..arr[i].vo.colorStr.."]"..arr[i].vo.name.."[/url]*"..arr[i].amount.."[/u]";
			else
				str = str.."]"..arr[i].vo.colorName.."[/url][/u]";
			end
			itemStr = itemStr..str;
		end
		local nameStr = "[url=playerClick_"..data.role_id.."]"..data.role_name.."[/url]";
		self.label.text = LanUtil.formateStr(LanUtil.getValue(144606), nameStr, itemStr);
	end

	local posY = self.label.mainContent.transform.localPosition.y - self.label.height;
	self.fenGeXian:setLocation(275, posY - 5, 0);

	self._height = self.label.height;
end

function Lua_CrazyEggsRecordItem:getHeight()
	return self._height + 10;
end

function Lua_CrazyEggsRecordItem:onPlayerSoundClick()
	self:superCall("onPlayerSoundClick");

	local urlStr = self.label:getUrlByMousePos();
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		if arr[1] == "showItem" then
			if self.itemInfo[tonumber(arr[2])] ~= nil then
				Lua_PackUtil.showItemInfo(self.itemInfo[tonumber(arr[2])]);
			else
				local vo = Lua_ToolVo.createToolVo(tonumber(arr[2]));
				Lua_PackUtil.showItemInfo(vo);
			end
		elseif arr[1] == "playerClick" then
			Lua_ChatUtil.playerMenuPopListShow({role_id = tonumber(arr[2])});
		end
	end
end

function Lua_CrazyEggsRecordItem:dispose()
	if self.fenGeXian ~= nil then
		self.fenGeXian:dispose();
		self.fenGeXian = nil;
	end
	self.itemInfo = {};
	self._height = 0;

	self:superCall("dispose");
end